@make(ais)
@aiInfo(topic=<Subtype declarations as renamings>,
number=[AI-00378/00],
classcode=[ST],
statuscode=[RE],
mainref=[08.05@\(16)],
date=[85-08-22])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
!class study 85-08-22
!status received 85-08-22
@end(toplines)
@topic{!topic Subtype declarations as renamings}
@end(history)

@subheading[!summary 85-08-22]


@subheading[!question 85-08-22]


@subheading[!recommendation 85-08-22]


!wording 85-08-22


@subheading[!discussion 85-08-22]


@begin(appendix)
@subheading[!appendix 85-08-08]
@begin(sectionGroup)
@mybar()

!section 08.05    (16) Brace Stout/Ron Brender   85-08-08            83-00604
!version 1983
!topic Subtype declarations as renamings
@end(sectionGroup)

A user of one validated Ada compiler made an inquiry as follows:

    LRM 8.5(16) says that "A subtype can be used to achieve the effect
    of renaming a type...".  This is not clearly defined.  My question
    is:

      Should the enumeration literals which belong to the type be
      directly visible when declaring a subtype of a non-directly
      visible enumeration type?

    Since the LRM does not specifically say, have the language lawyers
    said anything of this subject?  This would be a good thing to have
    clearly stated in the next LRM when it comes out.

I responded as follows:

    There is certainly nothing in LRM 3.3.2 on subtypes nor in 8.3  on
    visibility   that   supports  the  notion  that  using  a  subtype
    declaration to "rename" an enumeration type also has the effect of
    making  the  enumeration literals of the type visible at the place
    of the subtype declaration as well.  So our own conclusion is that
    this definitely does not occur.

    The sentence you cite is in a "note".  This means that it "is  not
    part of the Standard", but merely points out consequences that may
    not be immediately obvious.  In this case, we believe the  purpose
    of  the  note  is  to  explain  that  there  is no need for a type
    renaming declaration  because  a  normal  subtype  declaration  is
    sufficient.

    Your comment suggests a possible useful  effect  of  a  true  type
    renaming  that  is not provided by a subtype declaration; one that
    we have never heard suggested before.  We will pass  this  comment
    along to the Ada Language Maintenance Committee.

Unless I am way off base, this comment does not need to  be  processed
by  the  Ada  LMC  as an inquiry.  However, it should be retained as a
comment/idea to be considered for a possible future  revision  of  the
Standard.
   --------

@end(appendix)
